//*************************************************************
//			 Java application
//				  uTakanaTextvversion 1.4
//
//@@@@@@@@@@@@ҁF[g؁@@@
//@@@@@@@@@@쐬JnFQOOU^T
//@@@@@@@@@@ŏIXVFQOPP^T    [TN080/J70]
//*************************************************************
import java.awt.*;
import java.awt.datatransfer.*;
import java.awt.dnd.*;
import java.awt.event.*;
import java.io.*;
import java.util.List;

import javax.print.PrintException;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.filechooser.FileNameExtensionFilter;
import javax.swing.text.*;

import org.mozilla.universalchardet.UniversalDetector;

public class TakanaText extends JFrame implements ActionListener,DocumentListener,MouseListener,KeyListener,FocusListener,WindowListener,DropTargetListener {
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//
	public static void main(String[] args) {
		TakanaText frame=new TakanaText();
		frame.setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);	//E~ł͉Ȃiŏj
		frame.setVisible(true);
		frame.setLocationRelativeTo(null);	//ʂ̐^񒆂ɕ\
	}
	//
	final String title=" - TakanaText";	//^Cg̍Ōɕt
	JTextArea area;
	JTextComponent textComponent;
	//
	JMenuBar mainMenu=new JMenuBar();
	//
	JMenu file=new JMenu("t@C(F)");
	JMenuItem newFile=new JMenuItem("VK(N)");
	JMenuItem open=new JMenuItem("J(O)...");
	JMenuItem save=new JMenuItem("㏑ۑ(S)");
	JMenuItem saveAs=new JMenuItem("Otĕۑ(R)...");
	JMenuItem print=new JMenuItem("(P)...");
	JMenuItem exit=new JMenuItem("I(X)");
	//
	JMenu edit=new JMenu("ҏW(E)");
	JMenuItem cut=new JMenuItem("Jbg(X)");
	JMenuItem copy=new JMenuItem("Rs[(C)");
	JMenuItem paste=new JMenuItem("y[Xg(V)");
	JMenuItem replace=new JMenuItem("Eu(L)...");
	JMenuItem selectall=new JMenuItem("SđI(A)");
	//
	JMenu setting=new JMenu("ݒ(S)");
	JCheckBoxMenuItem linewrap=new JCheckBoxMenuItem("܂Ԃ(W)");
	JMenuItem textSize=new JMenuItem("TCY(Z)...");
	JMenuItem textFont=new JMenuItem("tHg(F)...");
	JMenuItem colorText=new JMenuItem("F(T)...");
	JMenuItem colorBack=new JMenuItem("wiF(B)...");
	//
	JMenu lineSeparator=new JMenu("ۑ̉sR[h");
	JRadioButtonMenuItem lineSeparatorCRLF=new JRadioButtonMenuItem("CRLF(Windows)");
	JRadioButtonMenuItem lineSeparatorLF=new JRadioButtonMenuItem("LF(UNIXn)");
	JRadioButtonMenuItem lineSeparatorCR=new JRadioButtonMenuItem("CR(Mac)");
	//
	JMenu charCode=new JMenu("ۑ̕R[h");
	JRadioButtonMenuItem charCodePre=new JRadioButtonMenuItem("Ɠ");
	JRadioButtonMenuItem charCodeSJIS=new JRadioButtonMenuItem("Shift_JIS");
	JRadioButtonMenuItem charCodeJIS=new JRadioButtonMenuItem("JIS(ISO-2202-JP)");
	JRadioButtonMenuItem charCodeEUC=new JRadioButtonMenuItem("EUC-JP");
	JRadioButtonMenuItem charCodeUTF8=new JRadioButtonMenuItem("UTF-8");
	JRadioButtonMenuItem charCodeUTF16=new JRadioButtonMenuItem("UTF-16");
	JRadioButtonMenuItem charCodeDefault=new JRadioButtonMenuItem("system default");
	//
	JMenu help=new JMenu("wv(H)");
	JMenuItem version=new JMenuItem("o[W(V)");
	//
	PopupMenu popupMenu=new PopupMenu("PopupMenu");;
	MenuItem popupCut=new MenuItem("Jbg");
	MenuItem popupCopy=new MenuItem("Rs[");
	MenuItem popupPaste=new MenuItem("y[Xg");
	MenuItem popupSelectall=new MenuItem("SđI");
	//
	JFileChooser chooser=new JFileChooser();
	File saveFile=null;
	//Eu_CAO
	TakanaTextReplaceDialog replaceDialog=new TakanaTextReplaceDialog(this);
	//SĔC
	TakanaTextPrint printWork=new TakanaTextPrint();
	//tHgύXp
	String[] fontList;
	String[] sizeList={"8","9","10","11","12","13","14","16","18","20","24","28","32","36","48","72"};
	//
	String br;				//sR[h
	String code,codePre;	//R[h
	//--------------------------------------
	//RXgN^
	//--------------------------------------
	public TakanaText(){
		//
		setTitle(""+title);
		setSize(500,600);
		//
		area=new JTextArea();
		area.setLineWrap(false);	//
		area.setFont(new Font("Dialog.plain",Font.PLAIN,12));	//
		area.setTabSize(4);
		textComponent=(JTextComponent)(area);
		JScrollPane scPanel=new JScrollPane(area);
		//Reig
		Container cp=getContentPane();
		cp.add(scPanel);
		//sR[hiWI{^ݒj
		ButtonGroup bgBlock=new ButtonGroup();
		bgBlock.add(lineSeparatorCRLF);
		bgBlock.add(lineSeparatorLF);
		bgBlock.add(lineSeparatorCR);
		br=System.getProperty("line.separator");	//l͂̃VXê
		if(br.equals("\n")){
			lineSeparatorLF.setSelected(true);
		}else if(br.equals("\r")){
			lineSeparatorCR.setSelected(true);
		}else/* if(br.equals("\r\n"))*/{
			lineSeparatorCRLF.setSelected(true);
		}
		//
		ButtonGroup bgCode=new ButtonGroup();
		bgCode.add(charCodePre);
		bgCode.add(charCodeSJIS);
		bgCode.add(charCodeJIS);
		bgCode.add(charCodeEUC);
		bgCode.add(charCodeUTF8);
		bgCode.add(charCodeUTF16);
		bgCode.add(charCodeDefault);
		//formatCode();	formatState
		//
		file.add(newFile);
		file.add(open);
		file.addSeparator();
		file.add(save);
		file.add(saveAs);
		file.addSeparator();
		file.add(print);
		file.addSeparator();
		file.add(exit);
		edit.add(cut);
		edit.add(copy);
		edit.add(paste);
		edit.addSeparator();
		edit.add(replace);
		edit.addSeparator();
		edit.add(selectall);
		setting.add(linewrap);
		setting.addSeparator();
		setting.add(textSize);
		setting.add(textFont);
		setting.addSeparator();
		setting.add(colorText);
		setting.add(colorBack);
		setting.addSeparator();
		lineSeparator.add(lineSeparatorCRLF);
		lineSeparator.add(lineSeparatorLF);
		lineSeparator.add(lineSeparatorCR);
		setting.add(lineSeparator);
		charCode.add(charCodePre);
		charCode.addSeparator();
		charCode.add(charCodeSJIS);
		charCode.add(charCodeJIS);
		charCode.add(charCodeEUC);
		charCode.add(charCodeUTF8);
		charCode.add(charCodeUTF16);
		charCode.add(charCodeDefault);
		setting.add(charCode);
		help.add(version);
		//
		setJMenuBar(mainMenu);
		mainMenu.add(file);
		mainMenu.add(edit);
		mainMenu.add(setting);
		mainMenu.add(help);
		//
		popupMenu.add(popupCut);
		popupMenu.add(popupCopy);
		popupMenu.add(popupPaste);
		popupMenu.addSeparator();
		popupMenu.add(popupSelectall);
		area.add(popupMenu);
		//j[jbNiL[{[hAlt+?őIj
		file.setMnemonic(KeyEvent.VK_F);
		newFile.setMnemonic(KeyEvent.VK_N);
		open.setMnemonic(KeyEvent.VK_O);
		save.setMnemonic(KeyEvent.VK_S);
		saveAs.setMnemonic(KeyEvent.VK_R);
		print.setMnemonic(KeyEvent.VK_P);
		exit.setMnemonic(KeyEvent.VK_X);
		edit.setMnemonic(KeyEvent.VK_E);
		cut.setMnemonic(KeyEvent.VK_X);
		copy.setMnemonic(KeyEvent.VK_C);
		paste.setMnemonic(KeyEvent.VK_V);
		replace.setMnemonic(KeyEvent.VK_L);
		selectall.setMnemonic(KeyEvent.VK_A);
		setting.setMnemonic(KeyEvent.VK_S);
		linewrap.setMnemonic(KeyEvent.VK_W);
		textSize.setMnemonic(KeyEvent.VK_Z);
		textFont.setMnemonic(KeyEvent.VK_F);
		colorText.setMnemonic(KeyEvent.VK_T);
		colorBack.setMnemonic(KeyEvent.VK_B);
		help.setMnemonic(KeyEvent.VK_H);
		version.setMnemonic(KeyEvent.VK_V);
		//ANZ[^[iL[{[h̃V[gJbgj
		newFile.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,Event.CTRL_MASK));
		open.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,Event.CTRL_MASK));
		save.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S,Event.CTRL_MASK));
		saveAs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_R,Event.CTRL_MASK));
		print.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_P,Event.CTRL_MASK));
		cut.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X,Event.CTRL_MASK));
		copy.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_C,Event.CTRL_MASK));
		paste.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V,Event.CTRL_MASK));
		replace.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_L,Event.CTRL_MASK));
		selectall.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,Event.CTRL_MASK));
		linewrap.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W,Event.CTRL_MASK));
		textSize.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_Z,Event.CTRL_MASK));
		textFont.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F,Event.CTRL_MASK));
		colorText.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_T,Event.CTRL_MASK));
		colorBack.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_B,Event.CTRL_MASK));
		//ẽCxg
		newFile.addActionListener(this);
		open.addActionListener(this);
		save.addActionListener(this);
		saveAs.addActionListener(this);
		print.addActionListener(this);
		exit.addActionListener(this);
		cut.addActionListener(this);
		copy.addActionListener(this);
		paste.addActionListener(this);
		replace.addActionListener(this);
		selectall.addActionListener(this);
		linewrap.addActionListener(this);
		textSize.addActionListener(this);
		textFont.addActionListener(this);
		colorText.addActionListener(this);
		colorBack.addActionListener(this);
		lineSeparatorCRLF.addActionListener(this);
		lineSeparatorLF.addActionListener(this);
		lineSeparatorCR.addActionListener(this);
		charCodePre.addActionListener(this);
		charCodeSJIS.addActionListener(this);
		charCodeJIS.addActionListener(this);
		charCodeEUC.addActionListener(this);
		charCodeUTF8.addActionListener(this);
		charCodeUTF16.addActionListener(this);
		charCodeDefault.addActionListener(this);
		version.addActionListener(this);
		popupCut.addActionListener(this);
		popupCopy.addActionListener(this);
		popupPaste.addActionListener(this);
		popupSelectall.addActionListener(this);
		//
		area.getDocument().addDocumentListener(this);
		area.addMouseListener(this);
		area.addKeyListener(this);
		area.addFocusListener(this);
		//
		addWindowListener(this);
		//
		formatState();
		enablePasteMenu();
		linewrap.setSelected(false);
		//VXegpłtHg擾
		GraphicsEnvironment localEnv=GraphicsEnvironment.getLocalGraphicsEnvironment();
		Font[] fonts=localEnv.getAllFonts();
		fontList=new String[fonts.length];
		for(int f=0;f<fonts.length;f++){
			fontList[f]=fonts[f].getFontName();
		}
		//hbOEhbv󂯎悤ɐݒ
		DropTarget target=new DropTarget((Component)area,DnDConstants.ACTION_COPY_OR_MOVE,this,true);
		setDropTarget(target);
		//
		chooser.addChoosableFileFilter(new FileNameExtensionFilter("eLXgt@C(*.txt)","txt"));
	}
	//--------------------------------------
	//
	//--------------------------------------
	public void actionPerformed(ActionEvent event) {
		Object object=event.getSource();
		if(object==newFile){
			actionNewFile();
		}else if(object==open){
			actionOpen();
		}else if(object==save){
			actionSave();
		}else if(object==saveAs){
			actionSaveAs();
		}else if(object==print){
			actionPrint();
		}else if(object==exit){
			actionExit();
		}else if(object==cut || object==popupCut){
			textComponent.cut();
			enableCutCopyMenu();
			enablePasteMenu();
		}else if(object==copy || object==popupCopy){
			textComponent.copy();
			enableCutCopyMenu();
			enablePasteMenu();
		}else if(object==paste || object==popupPaste){
			textComponent.paste();
			enableCutCopyMenu();
		}else if(object==replace){
			actionReplace();
		}else if(object==selectall || object==popupSelectall){
			textComponent.selectAll();
			enableCutCopyMenu();
		}else if(object==linewrap){
			actionLinewrap();
		}else if(object==textSize){
			actionTextSize();
		}else if(object==textFont){
			actionTextFont();
		}else if(object==colorText){
			actionColorText();
		}else if(object==colorBack){
			actionColorBack();
		}else if(object==lineSeparatorCRLF){
			br="\r\n";
		}else if(object==lineSeparatorLF){
			br="\n";
		}else if(object==lineSeparatorCR){
			br="\r";
		}else if(object==charCodePre){
			code=codePre;	//
		}else if(object==charCodeSJIS){
			code="SHIFT_JIS";
		}else if(object==charCodeJIS){
			code="ISO-2202-JP";
		}else if(object==charCodeEUC){
			code="EUC-JP";
		}else if(object==charCodeUTF8){
			code="UTF8";
		}else if(object==charCodeUTF16){
			code="UTF16";
		}else if(object==charCodeDefault){
			code=null;		//system default
		}else if(object==version){
			JOptionPane.showMessageDialog(TakanaText.this,
							"TakanaText version 1.4\n\nTakanaFactory\nhttp://www.takana.info/",
							"Version",JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//--------------------------------------
	//eLXgҏW烁j[̗LE
	//--------------------------------------
	public void insertUpdate(DocumentEvent event){
		enableSaveMenu(true);
	}
	public void removeUpdate(DocumentEvent event){
		enableSaveMenu(true);
	}
	public void changedUpdate(DocumentEvent event){
	}
	//--------------------------------------
	//}EX{^烁j[̗LEAE{^|bvAbvj[\
	//--------------------------------------
	public void mouseReleased(MouseEvent event){
		//}EX{^ꂽ
		if((event.getModifiers() & MouseEvent.BUTTON1_MASK)!=0){
			enableCutCopyMenu();
		}
		//}EXE{^ꂽ
		if(event.isPopupTrigger()){
			popupMenu.show(area,event.getX(),event.getY());
		}
	}
	public void mouseClicked(MouseEvent arg0) {}
	public void mouseEntered(MouseEvent arg0) {}
	public void mouseExited(MouseEvent arg0) {}
	public void mousePressed(MouseEvent arg0) {}
	//--------------------------------------
	//L[{[h̃L[JŃj[̗LE
	//--------------------------------------
	public void keyReleased(KeyEvent event){
		enableCutCopyMenu();
	}
	public void keyPressed(KeyEvent arg0) {}
	public void keyTyped(KeyEvent arg0) {}
	//--------------------------------------
	//tH[JX擾烁j[̗LE
	//--------------------------------------
	public void focusGained(FocusEvent event){
		enablePasteMenu();
	}
	public void focusLost(FocusEvent arg0) {}
	//--------------------------------------
	//~ŏIiIOɖۑf[^̏sj
	//--------------------------------------
	public void windowClosing(WindowEvent event){
		actionExit();
	}
	public void windowActivated(WindowEvent arg0) {}
	public void windowClosed(WindowEvent arg0) {}
	public void windowDeactivated(WindowEvent arg0) {}
	public void windowDeiconified(WindowEvent arg0) {}
	public void windowIconified(WindowEvent arg0) {}
	public void windowOpened(WindowEvent arg0) {}
	//-------------------------------------------------
	//j[̃ANV
	//-------------------------------------------------
	private void actionNewFile(){
		if(saveUpdatedDataAndContinue()){
			formatState();
		}
	}
	//j[t@CJ
	private void actionOpen(){
		if(saveUpdatedDataAndContinue()){
			if(getPath(FileDialog.LOAD)){
				loadData();
			}
		}
	}
	//hbOhbvŃt@CJiړIt@C̃pX󂯎j
	private void actionOpenByDrop(File dropFile){
		if(saveUpdatedDataAndContinue()){
			//ړIt@Cݒ
			saveFile=dropFile;
			setTitle(saveFile.getName()+title);
			//
			loadData();
		}
	}
	private void actionSave(){
		if(saveFile==null){
			actionSaveAs();
		}else{
			saveData();
		}
	}
	private void actionSaveAs(){
		if(getPath(FileDialog.SAVE)){
			saveData();
		}
	}
	private void actionPrint(){
		String header;
		if(saveFile!=null){
			header=saveFile.getName();
		}else{
			header="";
		}
		//
		String strData=area.getText();
		if( !strData.equals("") ){
			try{
				printWork.printString(strData, header);
			}catch(PrintException e){
				JOptionPane.showMessageDialog(this,"Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
			}
		}else{
			JOptionPane.showMessageDialog(this,"e܂B","x",JOptionPane.ERROR_MESSAGE);
		}
	}
	private void actionExit(){
		if(saveUpdatedDataAndContinue()){
			System.exit(0);
		}
	}
	private void actionReplace(){
		replaceDialog.setVisible(true);
		replaceDialog.setLocationRelativeTo(null);
	}
	private void actionLinewrap(){
		area.setLineWrap(linewrap.getState());
	}
	private void actionTextSize(){
		Object ret=JOptionPane.showInputDialog(TakanaText.this,"TCYIĂ","TCYI",
							JOptionPane.INFORMATION_MESSAGE,null,sizeList,String.valueOf(area.getFont().getSize()));
		if(ret!=null){
			area.setFont(area.getFont().deriveFont(Float.parseFloat((String)ret)));
		}
	}
	private void actionTextFont(){
		Object ret=JOptionPane.showInputDialog(TakanaText.this,"tHgIĂ","tHgI",
							JOptionPane.INFORMATION_MESSAGE,null,fontList,String.valueOf(area.getFont().getFontName()));
		if(ret!=null){
			Font tmpFont=area.getFont();
			area.setFont(new Font((String)ret,tmpFont.getStyle(),tmpFont.getSize()));
		}
	}
	private void actionColorText(){
		Color cc=JColorChooser.showDialog(null,"FI",area.getForeground());
		if(cc!=null){
			area.setForeground(cc);
		}
	}
	private void actionColorBack(){
		Color cc=JColorChooser.showDialog(null,"wiFI",area.getBackground());
		if(cc!=null){
			area.setBackground(cc);
		}
	}
	//---------------------------------------------
	//j[̗L
	//---------------------------------------------
	public void enableSaveMenu(boolean flag){
		if(saveFile==null){
			save.setEnabled(false);
		}else{
			save.setEnabled(flag);
		}
	}
	public void enableCutCopyMenu(){
		String selected=textComponent.getSelectedText();
		boolean flag=((selected!=null && selected.length()>0));
		cut.setEnabled(flag);
		copy.setEnabled(flag);
		popupCut.setEnabled(flag);
		popupCopy.setEnabled(flag);
	}
	private void enablePasteMenu(){
		Clipboard cb=Toolkit.getDefaultToolkit().getSystemClipboard();
		Transferable t=cb.getContents(this);
		paste.setEnabled(t.isDataFlavorSupported(DataFlavor.stringFlavor));
		popupPaste.setEnabled(t.isDataFlavorSupported(DataFlavor.stringFlavor));
	}
	//---------------------------------------------
	//ӏĂ΂ėp\bh
	//---------------------------------------------
	//Ԃ
	private void formatState(){
		setTitle(""+title);
		area.setText("");
		//
		saveFile=null;
		//
		enableSaveMenu(false);
		enableCutCopyMenu();
		//
		formatCode();	//R[h system default 
	}
	//VKt@CI̎ɁA݂̖ۑf[^ipOKȂtrueԂj
	private boolean saveUpdatedDataAndContinue(){
		//
		if(saveFile==null){
			if(area.getText().equals("")){
				return true;
			}
		}else{
			if(!save.isEnabled()){
				return true;
			}
		}
		//
		int ret=JOptionPane.showConfirmDialog(this,"eύXĂ܂B\nۑ܂H",
					"mF",JOptionPane.YES_NO_CANCEL_OPTION,JOptionPane.WARNING_MESSAGE);
		if(ret==JOptionPane.YES_OPTION){
			actionSave();
			if(saveFile==null){
				return false;
			}
		}else if(ret==JOptionPane.CANCEL_OPTION){
			return false;
		}
		return true;
	}
	//t@C_CAO\ĖړIt@C̃pX擾iLZfalseԂj
	private boolean getPath(int mode){
		//
		if(saveFile!=null){
			chooser.setSelectedFile(saveFile);
		}
		int ret=0;
		if(mode==FileDialog.SAVE){
			chooser.showSaveDialog(this);
		}else if(mode==FileDialog.LOAD){
			chooser.showOpenDialog(this);
		}
		if(ret==JFileChooser.APPROVE_OPTION){
			saveFile=chooser.getSelectedFile();
			setTitle(saveFile.getName()+title);
			return true;
		}else{
			return false;
		}
	}
	//݂̃f[^w肳Ăt@Cɕۑ
	private void saveData(){
		try{
			String line=area.getText();
			line=line.replaceAll("\n", br);			//sR[hFt@Cł̓j[őI񂾂́il̓VXếj
			//
			PrintWriter pw;
			if(code==null){			//w̕R[hŕۑisystem default Ȃ疢wŁj
				pw=new PrintWriter(new OutputStreamWriter(new FileOutputStream(saveFile)));
			}else{
				pw=new PrintWriter(new OutputStreamWriter(new FileOutputStream(saveFile),code));
			}
			//PrintWriter pw=new PrintWriter(new BufferedWriter(new FileWriter(saveFile)));
			pw.print(line);
			pw.close();
			//
			enableSaveMenu(false);
			//
			checkCode(saveFile);	//ŌɕR[h̏𔽉f
		}catch(IOException e){
			JOptionPane.showMessageDialog(this,"t@C݂Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//w肳Ăt@CJ
	private void loadData(){
		try{
			checkCode(saveFile);	//ŏɕR[h𒲂ׂ
			//
			String line;
			//
			BufferedReader br;
			if(code==null){			//ꂽR[hœǂݍ݁iȂΎFj
				br=new BufferedReader(new InputStreamReader(new FileInputStream(saveFile),"JISAutoDetect"));
			}else{
				br=new BufferedReader(new InputStreamReader(new FileInputStream(saveFile),code));
			}
			//BufferedReader br=new BufferedReader(new FileReader(saveFile));
			area.setText("");
			while((line=br.readLine())!=null){
				area.append(line+"\n");				//sR[hFJavał\nɁiJtextAreaŉsƂȂ邩j
			}
			br.close();
			//擪Ɉړ
			textComponent.setCaretPosition(0);
			//
			enableSaveMenu(false);
			enableCutCopyMenu();
		}catch(IOException e){
			JOptionPane.showMessageDialog(this,"t@Cǂݍ݂Ɏs܂B","G[",JOptionPane.ERROR_MESSAGE);
		}
	}
	//--------------------------------------
	//R[h𒲂ׂ
	//--------------------------------------
	private void checkCode(File file){
		//
		if(file==null){
			formatCode();
			return;
		}
		//
		try {
			UniversalDetector detector=new UniversalDetector(null);
			FileInputStream fis=new FileInputStream(file);
			//
			byte[] buf=new byte[4096];
			int nread;
			while((nread=fis.read(buf))>0 && !detector.isDone()){
				detector.handleData(buf, 0, nread);
			}
			detector.dataEnd();
			//
			String encoding=detector.getDetectedCharset();
			if(encoding==null){
				formatCode();	//sȂiAt@xbĝ݂łj system default
			}else{
				code=codePre=encoding;
				charCodePre.setText("Ɠ("+encoding+")");	//ꂽR[hj[ɕ\
				charCodePre.setEnabled(true);
				charCodePre.setSelected(true);
			}
			//
			detector.reset();
			//
			fis.close();
		} catch (FileNotFoundException fnfe) {
			formatCode();	//G[Ȃ system default
		} catch (IOException ioe) {
			formatCode();	//G[Ȃ system default
		}
	}
	private void formatCode(){		//R[hisystem default ɂj
		code=codePre=null;
		charCodePre.setText("Ɠ");
		charCodePre.setEnabled(false);
		charCodeDefault.setSelected(true);
	}
	//--------------------------------------
	//hbOhbv󂯎
	//--------------------------------------
	public void dragEnter(DropTargetDragEvent dtde) {
		dtde.acceptDrag(dtde.getDropAction());
	}
	public void dragOver(DropTargetDragEvent arg0) {}
	public void dropActionChanged(DropTargetDragEvent arg0) {}
	public void dragExit(DropTargetEvent arg0) {}
	public void drop(DropTargetDropEvent dtde) {
		try{
			//Javãt@CXgł
			Transferable trans=dtde.getTransferable();
			if(trans.isDataFlavorSupported(DataFlavor.javaFileListFlavor)){
				dtde.acceptDrop(dtde.getDropAction());
				List list=(List)trans.getTransferData(DataFlavor.javaFileListFlavor);
				//Xgvf1ŁAꂪt@Cł
				if(list.size()==1){
					File dropFile=(File)list.get(0);
					if(dropFile.isFile()){
						//ǂݍ
						actionOpenByDrop(dropFile);
						dtde.getDropTargetContext().dropComplete(true);
					}else{
						JOptionPane.showMessageDialog(this,"tH_IĂ܂B","G[",JOptionPane.ERROR_MESSAGE);
						dtde.getDropTargetContext().dropComplete(false);
					}
				}else{
					JOptionPane.showMessageDialog(this,"̃t@CIĂ܂B","G[",JOptionPane.ERROR_MESSAGE);
					dtde.getDropTargetContext().dropComplete(true);
				}
			}else{
				JOptionPane.showMessageDialog(this,"T|[gÕf[^`łB","G[",JOptionPane.ERROR_MESSAGE);
				dtde.rejectDrop();
			}
		}catch(IOException ioe){
			JOptionPane.showMessageDialog(this,"̃f[^͎gpł܂B","G[",JOptionPane.ERROR_MESSAGE);
			dtde.rejectDrop();
		}catch(UnsupportedFlavorException ufe){
			JOptionPane.showMessageDialog(this,"T|[gÕf[^`łB","G[",JOptionPane.ERROR_MESSAGE);
			dtde.rejectDrop();
		}
	}
}
