import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.Frame;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.KeyEvent;

import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.event.DocumentEvent;
import javax.swing.event.DocumentListener;


//------------------------------------
//Eu_CAO
//------------------------------------
public class TakanaTextReplaceDialog extends JDialog implements ActionListener,DocumentListener{
	//EclipsȅꍇAVACY\NXłꂪȂƌxo
	private static final long serialVersionUID=0;
	//eNX
	TakanaText parent;
	//
	JTextField before=new JTextField(20);
	JTextField after=new JTextField(20);
	//
	JButton search=new JButton("(F)");
	JButton replace=new JButton("uĎ(R)");
	JButton all=new JButton("ׂĒu(A)");
	JButton cancel=new JButton("LZ");
	//u񐔂i[iuׂĒuvŎgj
	int count=0;
	//------------------------------------
	//RXgN^
	//------------------------------------
	public TakanaTextReplaceDialog(Frame owner){
		super(owner,"Eu",false);
		//
		parent=(TakanaText)owner;
		//
		setSize(480,130);
		//
		JPanel textPanel=new JPanel();
		textPanel.add(new JLabel("镶F@"));
		textPanel.add(before);
		textPanel.add(new JLabel("u̕F@"));
		textPanel.add(after);
		//
		JPanel buttonPanel=new JPanel();
		buttonPanel.add(search);
		buttonPanel.add(replace);
		buttonPanel.add(all);
		buttonPanel.add(cancel);
		//
		search.setMnemonic(KeyEvent.VK_F);
		replace.setMnemonic(KeyEvent.VK_R);
		all.setMnemonic(KeyEvent.VK_A);
		//Reig
		Container cp=getContentPane();
		cp.add(textPanel,BorderLayout.CENTER);
		cp.add(buttonPanel,BorderLayout.SOUTH);
		//
		before.getDocument().addDocumentListener(this);
		search.addActionListener(this);
		replace.addActionListener(this);
		all.addActionListener(this);
		cancel.addActionListener(this);
		//ŏɃ{^̗LEݒ
		enableButtons();
	}
	//------------------------------------
	//{^Cxg
	//------------------------------------
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==search){
			actionSearch(false);
		}else if(e.getSource()==replace){
			actionReplace(false);
		}else if(e.getSource()==all){
			actionAll();
		}else if(e.getSource()==cancel){
			setVisible(false);
		}
	}
	//
	private boolean actionSearch(boolean allReplaceFlag){
		String nowText=parent.textComponent.getText();
		String searchText=before.getText();
		//Jnʒu͑II[iIȂCaretʒuj
		int startPoint=parent.textComponent.getSelectionEnd();
		//֌Ă
		int start=nowText.indexOf(searchText,startPoint);
		//uׂĒuvłȂΐ擪ɖ߂đ
		if(!allReplaceFlag){
			if(start==-1){
				start=nowText.indexOf(searchText);
			}
		}
		//trueԂ
		if(start!=-1){
			parent.textComponent.setCaretPosition(start);
			parent.textComponent.moveCaretPosition(start+searchText.length());
			parent.enableCutCopyMenu();
			return true;
		}else{
			if(!allReplaceFlag){	//uׂĒuvȂ_CAO\Ȃ
				JOptionPane.showMessageDialog(this,"\""+searchText+"\"܂","TextEdit",JOptionPane.INFORMATION_MESSAGE);
			}
			return false;
		}
	}
	private boolean actionReplace(boolean allReplaceFlag){
		//Iς݂łΒu
		String selected=parent.textComponent.getSelectedText();
		if(selected!=null && selected.equals(before.getText())){
			parent.textComponent.replaceSelection(after.getText());
			parent.enableSaveMenu(true);
			if(allReplaceFlag){	//uׂĒuvȂu񐔂i[
				count++;
			}
		}
		//itrueԂj
		return actionSearch(allReplaceFlag);
	}
	private void actionAll(){
		//擪猟Jn
		parent.textComponent.setCaretPosition(0);
		//I[܂ňʂu
		count=0;
		while(actionReplace(true)){	//_CAO\ItƐ擪ɖ߂点Ȃ߂̃tO
			//Ȃ
		}
		//Caretʒu擪
		parent.textComponent.setCaretPosition(0);
		//
		if(count>0){
			JOptionPane.showMessageDialog(this,count+"u܂","TextEdit",JOptionPane.INFORMATION_MESSAGE);
		}else{
			JOptionPane.showMessageDialog(this,"\""+before.getText()+"\"܂","TextEdit",JOptionPane.INFORMATION_MESSAGE);
		}
	}
	//------------------------------------
	//eLXgҏWCxg
	//------------------------------------
	public void insertUpdate(DocumentEvent arg0) {
		enableButtons();
	}
	public void removeUpdate(DocumentEvent arg0) {
		enableButtons();
	}
	public void changedUpdate(DocumentEvent arg0) {
	}
	//̓͂ɂ킹ă{^LEݒ
	private void enableButtons(){
		if(before.getText().equals("")){
			search.setEnabled(false);
			replace.setEnabled(false);
			all.setEnabled(false);
		}else{
			search.setEnabled(true);
			replace.setEnabled(true);
			all.setEnabled(true);
		}
	}
}

